#==========================================================================
#     FileName: bin2gray2bin.py
#         Desc: This is python function to convert between Binary Code & Gray Code 
#       Author: Kechang.Shao
#        Email: shao.kc@163.com
#     HomePage: 
#      Version: 0.0.1
#   LastChange: 2016-02-18 07:25:00
#      History:
#==========================================================================

import string

##############################################
##Covert gray code to binary code#############
##############################################
def gray2bin(gray_code_origin,bit_wise = 8):
    if len(gray_code_origin) < bit_wise:
        gray_code = str(0) * (bit_wise-len(gray_code_origin)) + gray_code_origin
    elif len(gray_code_origin) > bit_wise:
        gray_code = gray_code_origin[-bit_wise:]
    else:
        gray_code = gray_code_origin

    gray_code_reverse = gray_code

    length_gray_code_reverse = len(gray_code_reverse)

    bin_list = []
    bin_list.append(str(int(gray_code_reverse[0])))

    j = 1
    while j < length_gray_code_reverse:
        bin_list.append(str(int(gray_code_reverse[j]) ^ int(bin_list[j-1]) ) )
        j = j + 1;

    bin_code = "".join(bin_list)
#    print (str(gray_code) + "<---->" + str(bin_code))
    return str(bin_code)


##############################################
##Covert binary code to gray code#############
##############################################
def bin2gray(binary_code_origin,bit_wise = 8):
    if len(binary_code_origin) < bit_wise:
        binary_code = str(0) * (bit_wise-len(binary_code_origin)) + binary_code_origin
    elif len(binary_code_origin) > bit_wise:
        binary_code = binary_code_origin[-bit_wise:]
    else:
        binary_code = binary_code_origin
    binary_code_reverse = binary_code[::-1]

    j = 0
    gray_list = []

    length_binary_code_reverse = len(binary_code_reverse)

    while j < length_binary_code_reverse - 1:
        gray_list.append( str(int(binary_code_reverse[j]) ^ int(binary_code_reverse[j+1]) ) )
        j = j + 1;

    gray_list.append(str(int(binary_code_reverse[j])))
    gray_code = "".join(gray_list)[::-1]
    #print (str(binary_code) + "," + str(gray_code))
    return gray_code


##############################################
##Main Entry##################################
##############################################
def main():
    bit_wise = 8
    for i in range(0,2 ** bit_wise):
#        print ("-------------------------------------------")
        binary_code_origin = str(bin(i))[2:]
        print (str(i) + "," + str(bin(i)),end=',')
        gray_code = bin2gray(binary_code_origin,bit_wise)
        binary_code = gray2bin(gray_code)
        if int(binary_code_origin) != int(binary_code):
            print (binary_code)
            print (binary_code_origin)
            print ("Error")

